// *******************************************************************
// File    : PhotoTips.cs 
// Author  : Igor Tolmachev
// Email   : info@itsamples.com
// Web     : www.itsamples.com 
// You are free to use/modify this code but leave this header intact.
// *******************************************************************

using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace ExifDataChanger
{
	/// <summary>
	/// Summary description for PhotoTips.
	/// </summary>
	public class PhotoTips : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label labelTipText;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public PhotoTips()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.labelTipText = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// labelTipText
			// 
			this.labelTipText.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.labelTipText.Location = new System.Drawing.Point(8, 8);
			this.labelTipText.Name = "labelTipText";
			this.labelTipText.Size = new System.Drawing.Size(320, 200);
			this.labelTipText.TabIndex = 2;
			this.labelTipText.Click += new System.EventHandler(this.OnTipClick);
			// 
			// PhotoTips
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.Color.Beige;
			this.ClientSize = new System.Drawing.Size(336, 214);
			this.ControlBox = false;
			this.Controls.Add(this.labelTipText);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.Name = "PhotoTips";
			this.ShowInTaskbar = false;
			this.TopMost = true;
			this.Click += new System.EventHandler(this.OnClick);
			this.Load += new System.EventHandler(this.OnLoad);
			this.Deactivate += new System.EventHandler(this.OnDeactivated);
			this.ResumeLayout(false);

		}
		#endregion

		private void OnClick(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void OnDeactivated(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void OnLoad(object sender, System.EventArgs e)
		{
			int nScreenWidth = SystemInformation.WorkingArea.Width;
			int nScreenHeight = SystemInformation.WorkingArea.Height;
			int nFormWidth = this.Width;
			int nFormHeight = this.Height;
			int nX = MousePosition.X;
			int nY = MousePosition.Y;
			int nLeft = nX;
			int nTop = nY;

			if(nLeft+nFormWidth>nScreenWidth) nLeft -= nFormWidth;
			if(nTop+nFormHeight>nScreenHeight) nTop -= nFormHeight;
			
			this.Left = nLeft;
			this.Top = nTop;
		}

		public void SetTipText(string strText)
		{
			this.labelTipText.Text = strText;

			Graphics g = System.Drawing.Graphics.FromHwnd(this.labelTipText.Handle);
			int nHeight = (int)g.MeasureString(strText, this.labelTipText.Font, this.labelTipText.Width).Height;

			this.Height = nHeight+20;
			
			g.Dispose();
		}

		private void OnTipClick(object sender, System.EventArgs e)
		{
			this.Close();
		}
	}
}
