// *******************************************************************
// File    : StatusBarProgressPane.cs 
// Author  : Igor Tolmachev
// Email   : info@itsamples.com
// Web     : www.itsamples.com 
// You are free to use/modify this code but leave this header intact.
// *******************************************************************

using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Windows.Forms;

namespace ExifDataChanger
{
	public class StatusBarProgressPanel : StatusBarPanel
	{
		private bool m_bIsAdded = false;
		private ColorProgressBar progressBar = new ColorProgressBar();
		[Category("Progress")]
		public ColorProgressBar ProgressBar
		{
			get { return progressBar; }
		}

		public StatusBarProgressPanel() : base()
		{
			// Just to be safe
			this.Style = System.Windows.Forms.StatusBarPanelStyle.OwnerDraw;
		}

		public void ParentDrawItemHandler(object sender, StatusBarDrawItemEventArgs sbdevent)
		{
			// Only add this once to the parent's control container
			if (m_bIsAdded == false)
			{
				this.Parent.Controls.Add(this.progressBar);
				this.m_bIsAdded = true;
			}

			// Get the bounds of this panel and copy to the progress bar's bounds
			if(sbdevent.Panel == this)
			{
				Rectangle rcBounds = sbdevent.Bounds;
				rcBounds.Inflate(1,1);
				progressBar.Bounds = rcBounds;
			}
		}
	}
}
